#include<bits/stdc++.h>
using namespace std;

#define int ll

#define PII pair<int, int>
#define VI vector<int>
#define VPII vector<PII>
#define LL long long
#define f first
#define s second
#define MP make_pair
#define PB push_back
#define LD long double
#define endl '\n'
#define ALL(c) (c).begin(), (c).end()
#define SIZ(c) (int)(c).size()
#define REP(i, n) for (int i = 0; i < (int)(n); i++)
#define FOR(i, b, e) for (int i = (b); i <= (int)(e); i++)
#define FORD(i, b, e) for (int i = (b); i >= (int)(e); i--)
#define ll LL
#define mp MP
#define pb PB
#define st f
#define nd s
#define eb emplace_back
const int inf = 1e9 + 7;
const LL INF = 1e18L + 7;

#define sim template<class n
sim, class s> ostream & operator << (ostream &p, pair<n, s> x)
{return p << "<" << x.f << ", " << x.s << ">";}
sim> auto operator << (ostream &p, n y) ->
typename enable_if<!is_same<n, string>::value, decltype(y.begin(), p)>::type
{int o = 0; for (auto c : y) {if (o++) p << ", "; p << c;} return p << "}";}
void dor() {cerr << endl;}
sim, class...s> void dor(n p, s...y) {cerr << p << " "; dor(y...);}
sim, class s> void mini(n &p, s y) {if (p > y) p = y;}
sim, class s> void maxi(n &p, s y) {if (p < y) p = y;}

#ifdef DEB
#define debug(...) dor(__FUNCTION__, ":", __LINE__, ": ", __VA_ARGS__)
#else
#define debug(...)
#endif

#define I(x) #x " =", (x), " "
#define A(a, i) #a "[" #i " =", i, "] =", a[i], " "



const int N = 1e5+7;

int n;

int x[N];
int y[N];

int ilo(int a, int b, int c)
{
	return (x[c]-x[a])*(y[b]-y[a])-(x[b]-x[a])*(y[c]-y[a]);
}

bool prawo(int a, int b, int c)
{
	return ilo(a, b, c)>0;
}

VI hull()
{
	VI s, u, l;
	
	for(int i = 1; i <= n; ++i)
	{
		s.pb(i);
	}
	
	sort(ALL(s), [](int a, int b)
	{
		return mp(x[a], y[a])<mp(x[b], y[b]);
	});
	
	for(auto it:s)
	{
		while(u.size()>=2 && !prawo(u[u.size()-2], u.back(), it))
			u.pop_back();
			
		u.pb(it);
	}
	
	reverse(ALL(s));
	
	for(auto it:s)
	{
		while(l.size()>=2 && !prawo(l[l.size()-2], l.back(), it))
			l.pop_back();
			
		l.pb(it);
	}
	
	u.pop_back();
	l.pop_back();
	
	for(auto it:l)
		u.pb(it);
		
	reverse(ALL(u));
	return u;
}

bool ot[N], is[N];

int bins(vector<int>& v, int a, int b)
{
	int st = 1, en = SIZ(v) - 2, r = 1, mid = (st + en) / 2;
	while (st <= en)
	{
		if (ilo(a, b, v[mid]) > 0)
		{
			r = max(r, mid);
			st = mid + 1;
		}
		else
		{
			en = mid - 1;
		}
		mid = (st + en) / 2;
	}
	return r;
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	
	cin >> n;
	
	for(int i = 1; i <= n; ++i)
	{
		cin >> x[i] >> y[i];
	}
	
	VI h = hull();
	
	int best = inf;
	
	for(auto it:h)
	{
		best = min(best, it);
	}	
	
	VI v;
	
	for(int i = 0; i < h.size(); ++i)
	{
		if(h[i]==best)
		{
			for(int j = 0; j < h.size(); ++j)
			{
				v.pb(h[(i+j)%h.size()]);
			}
			
			break;
		}
	}
	
	if (SIZ(v) == n)
	{
		cout << "3 " << n - 2 << " " << n << endl;
		return 0;
	}
	for (auto i : v)
	{
		ot[i] = 1;
	}
	is[v[0]] = 1;
	FOR(i, 1, n)
	{
		if (ot[i])
		{
			continue;
		}
		int ind = bins(v, v[0], i);
		is[v[ind]] = 1;
		is[v[ind + 1]] = 1;
	}
	int r = 0;
	FOR(i, 1, n)
	{
		if (is[i])
		{
			r++;
		}
	}
	cout << "4 " << n - SIZ(v) << " " << r + n - SIZ(v) << endl;
}




